<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:op="utc.fr:ics/opale3" xmlns:java="http://xml.apache.org/xslt/java" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:emrd="scpf.org:opale/emeraude" exclude-result-prefixes="op java sp emrd " >

<xsl:param name="vSpace"/>
<xsl:param name="vCode"/>

<xsl:template match="/sc:item">
<xsl:apply-templates select="emrd:activity"/>
</xsl:template>

<xsl:template match="sc:item/emrd:activity">
	<title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:uM"><xsl:value-of select="sp:title"/></xsl:for-each></title>
<xsl:apply-templates/>
</xsl:template>


<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:expStep[@sc:refUri]">
<attrRef nm="emrd_activity:expStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:practQuestStep[@sc:refUri]">
<attrRef nm="emrd_activity:practQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:mcqSQuestStep[@sc:refUri]">
<attrRef nm="emrd_activity:mcqSQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:mcqMQuestStep[@sc:refUri]">
<attrRef nm="emrd_activity:mcqMQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:matchQuestStep[@sc:refUri]">
<attrRef nm="emrd_activity:matchQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:ordWQuestStep[@sc:refUri]">
<attrRef nm="emrd_activity:ordWQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:clozeQuestStep[@sc:refUri]">
<attrRef nm="emrd_activity:clozeQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:fieldQuestStep[@sc:refUri]">
<attrRef nm="emrd_activity:fieldQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:comment[@sc:refUri]">
<attrRef nm="emrd_activity:comment" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>



				
			


<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:expStep[@sc:refUri]">
<attrRef nm="emrd_activityDiv:expStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:practQuestStep[@sc:refUri]">
<attrRef nm="emrd_activityDiv:practQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:mcqSQuestStep[@sc:refUri]">
<attrRef nm="emrd_activityDiv:mcqSQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:mcqMQuestStep[@sc:refUri]">
<attrRef nm="emrd_activityDiv:mcqMQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:matchQuestStep[@sc:refUri]">
<attrRef nm="emrd_activityDiv:matchQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:ordWQuestStep[@sc:refUri]">
<attrRef nm="emrd_activityDiv:ordWQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:clozeQuestStep[@sc:refUri]">
<attrRef nm="emrd_activityDiv:clozeQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:fieldQuestStep[@sc:refUri]">
<attrRef nm="emrd_activityDiv:fieldQuestStep" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>


<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:img[@sc:refUri]">
<attrRef nm="op_res:img" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:tab[@sc:refUri]">
<attrRef nm="op_res:tab" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:graph[@sc:refUri]">
<attrRef nm="op_res:graph" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:vid[@sc:refUri]">
<attrRef nm="op_res:vid" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:int[@sc:refUri]">
<attrRef nm="op_res:int" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:zoom[@sc:refUri]">
<attrRef nm="op_res:zoom" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:res/sp:form[@sc:refUri]">
<attrRef nm="op_res:form" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>



				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='acr'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:uLinkTag:acr" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='glos'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:uLinkTag:glos" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='bib'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:uLinkTag:bib" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='docLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:uLinkTag:docLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='resLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:uLinkTag:resLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ucLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:uLinkTag:ucLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='form'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:inlineImgTag:form" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:txt]">
<attrRef nm="op_txt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>

				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='acr'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:uLinkTag:acr" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='glos'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:uLinkTag:glos" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='bib'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:uLinkTag:bib" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='docLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:uLinkTag:docLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='resLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:uLinkTag:resLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ucLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:uLinkTag:ucLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='form'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:inlineImgTag:form" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:qTxt]">
<attrRef nm="op_qTxt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>

<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:txtRes/sp:img[@sc:refUri]">
<attrRef nm="op_txtRes:img" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>




				
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='acr'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:uLinkTag:acr" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='glos'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:uLinkTag:glos" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='bib'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:uLinkTag:bib" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='docLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:uLinkTag:docLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='resLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:uLinkTag:resLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ucLnk'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:uLinkTag:ucLnk" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='form'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:inlineImgTag:form" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:clozeTxt]">
<attrRef nm="op_clozeTxt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>


				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='acr'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:labelTxt]">
<attrRef nm="op_labelTxt:uLinkTag:acr" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='glos'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:labelTxt]">
<attrRef nm="op_labelTxt:uLinkTag:glos" refUri="{@sc:refUri}"/>
</xsl:template>
			
				<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:uLink[@role='ref'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:labelTxt]">
<attrRef nm="op_labelTxt:uLinkTag:ref" refUri="{@sc:refUri}"/>
</xsl:template>
			<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='form'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:labelTxt]">
<attrRef nm="op_labelTxt:inlineImgTag:form" refUri="{@sc:refUri}"/>
</xsl:template>
<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="sc:inlineImg[@role='ico'][ancestor::*[namespace-uri(.)!='http://www.utc.fr/ics/scenari/v3/core'][1]/self::op:labelTxt]">
<attrRef nm="op_labelTxt:inlineImgTag:ico" refUri="{@sc:refUri}"/>
</xsl:template>


<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:labelImg/sp:img[@sc:refUri]">
<attrRef nm="op_labelImg:img" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>

				
			








<xsl:template xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:genRef/sp:ref[@sc:refUri]">
<xsl:if test="preceding-sibling::sp:*[@sc:refUri=current()/@sc:refUri and (name()='sp:ref')]">
<cPbs><pb msg="Un item a été référencé plusieurs fois !" typ="Error">
<xsl:value-of select="formatStr('Veuillez supprimer une des références à l&apos;&apos;item %s.', @sc:refUri)"/>
</pb></cPbs>
</xsl:if>
<attrRef nm="op_genRef:ref" refUri="{@sc:refUri}"/>
<xsl:apply-templates/>
</xsl:template>





<xsl:template match="text()|@*"/>
</xsl:stylesheet>