<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:op="utc.fr:ics/opale3" xmlns:java="http://xml.apache.org/xslt/java" xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:sp="http://www.utc.fr/ics/scenari/v3/primitive" xmlns:sc="http://www.utc.fr/ics/scenari/v3/core" xmlns:emrd="scpf.org:opale/emeraude" exclude-result-prefixes="op java sfacet sp emrd " extension-element-prefixes="op java sfacet sp emrd " >

<xsl:param name="pItem"/>
<xsl:param name="pIdSubItem"/>
<xsl:param name="pOutlineContext"/>
<xsl:param name="pIncludeTitle"/>

<xsl:template match="/sc:item">
<xsl:choose>
<xsl:when test="$pIdSubItem">
<itemRoot xp="id('{$pIdSubItem}')">
<xsl:if test="$pIncludeTitle"><xsl:apply-templates select="id($pIdSubItem)/*[last()]" mode="titleNode"/></xsl:if>
<xsl:apply-templates select="id($pIdSubItem)/*[last()]" mode="children"/>
</itemRoot>
</xsl:when>
<xsl:otherwise>
<itemRoot xp="sc:item">
<xsl:if test="$pIncludeTitle"><xsl:apply-templates select="emrd:activity" mode="titleNode"/></xsl:if>
<xsl:apply-templates select="emrd:activity" mode="children"/>
</itemRoot>
</xsl:otherwise>
</xsl:choose>
</xsl:template>

<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="emrd:activity">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:uM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="emrd:activity">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:expStep">
<node name="Grain de contenu" xp="emrd:activity/sp:expStep[{count(preceding-sibling::sp:expStep) + 1}]">
<xsl:choose>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:practQuestStep">
<node name="Exercice rédactionnel" xp="emrd:activity/sp:practQuestStep[{count(preceding-sibling::sp:practQuestStep) + 1}]">
<xsl:choose>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:comment">
<node name="Commentaire global" xp="emrd:activity/sp:comment[{count(preceding-sibling::sp:comment) + 1}]">
<xsl:choose>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activity/sp:conclu">
<node name="Conclusion" xp="emrd:activity/sp:conclu[{count(preceding-sibling::sp:conclu) + 1}]">
<xsl:choose>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="emrd:activityDiv">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="emrd:activityDivM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="emrd:activityDiv">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:expStep">
<node name="Grain de contenu" xp="emrd:activityDiv/sp:expStep[{count(preceding-sibling::sp:expStep) + 1}]">
<xsl:choose>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:activityDiv/sp:practQuestStep">
<node name="Exercice rédactionnel" xp="emrd:activityDiv/sp:practQuestStep[{count(preceding-sibling::sp:practQuestStep) + 1}]">
<xsl:choose>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:field">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:exeM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:res">
<titleNode title=""/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:res">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:txtRes">
<xsl:variable name="vTitle"/>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:txtRes">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:cloze">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:exeM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:ordWord">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:exeM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:match">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:exeM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:label">
<titleNode title=""/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:label">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:labelImg">
<titleNode title=""/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:labelImg">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:mcqMur">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:exeM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:mcqSur">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:exeM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:practUc">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:exeM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:practUc">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:practUcQ">
<titleNode title=""/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:practUcQ">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:pb">
<titleNode title=""/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:pb">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:expUc">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:uM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:expUc">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:expUc/sp:div">
<node name="Partie" xp="op:expUc/sp:div[{count(preceding-sibling::sp:div) + 1}]">
<xsl:variable name="vTitle"/>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<xsl:choose>
<xsl:when test="$vTitleInMeta and @sc:refUri">
<titleNode title="{$vTitleInMeta}"/>
<sfacet:callOutline includeTitle="false" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:when test="$vTitleInMeta">
<titleNode title="{$vTitleInMeta}"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:expUcDiv">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="op:expUcDivM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:expUcDiv">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="op:expUcDiv/sp:div">
<node name="Sous-partie" xp="op:expUcDiv/sp:div[{count(preceding-sibling::sp:div) + 1}]">
<xsl:variable name="vTitle"/>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<xsl:choose>
<xsl:when test="$vTitleInMeta and @sc:refUri">
<titleNode title="{$vTitleInMeta}"/>
<sfacet:callOutline includeTitle="false" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:when test="$vTitleInMeta">
<titleNode title="{$vTitleInMeta}"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="op:genRef">
<titleNode title=""/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="op:genRef">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="titleNode" match="emrd:pre">
<xsl:variable name="vTitle"><title><xsl:for-each xmlns:xsl="http://www.w3.org/1999/XSL/Transform" select="emrd:preM"><xsl:value-of select="sp:title"/></xsl:for-each></title></xsl:variable>
<xsl:variable select="string($vTitle)" name="vTitleInMeta"/>
<titleNode title="{$vTitleInMeta}"/>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" mode="children" match="emrd:pre">
<children>
<xsl:apply-templates/>
</children>
</xsl:template>
<xsl:template xmlns:sfacet="xalan://com.scenari.m.bdp.facet.outline.XslExtFacet" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" match="emrd:pre/sp:pre">
<node name="Pré-requis" xp="emrd:pre/sp:pre[{count(preceding-sibling::sp:pre) + 1}]">
<xsl:choose>
<xsl:when test="@sc:refUri">
<sfacet:callOutline includeTitle="true" refUri="{@sc:refUri}"/>
</xsl:when>
<xsl:otherwise>
<xsl:apply-templates mode="titleNode" select="*[last()]"/>
<xsl:apply-templates mode="children" select="*[last()]"/>
</xsl:otherwise>
</xsl:choose>
</node>
</xsl:template>


<xsl:template match="node()|@*"/>
<xsl:template match="node()|@*" mode="titleNode"/>
<xsl:template match="node()|@*" mode="children"/>
</xsl:stylesheet>